from Screens.Screen import Screen
from Components.Label import Label
from Components.ActionMap import ActionMap
from Screens.MessageBox import MessageBox
from Plugins.Plugin import PluginDescriptor
from lxml import html
import os
import requests
from Components.AVSwitch import AVSwitch
from enigma import ePicLoad
from Components.Pixmap import Pixmap
from requests.cookies import RequestsCookieJar
from enigma import eConsoleAppContainer
from Plugins.Extensions.myKCCCAM.VirtualKeyBoardPath.VirtualKeyBoard import VirtualKeyBoard

cmd = "chmod 755 /usr/lib/enigma2/python/Plugins/Extensions/myKCCCAM/akce.sh"
os.system(cmd)


class HalloWorldMsg(Screen):
    skin = '''
        <screen position="130,150" size="460,150" title="my KCCcam generator">
            <widget name="myLabel" position="10,60" size="200,40" font="Regular;20"/>
            <ePixmap name="green" position="262,50" zPosition="2" size="880,480" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/myKCCCAM/x.png" transparent="1" alphatest="on" />
        </screen>
    '''

    def __init__(self, session, args=0):
        self.session = session
        Screen.__init__(self, session)
        self.picload = ePicLoad()
        self['myLabel'] = Label(_('Press OK'))
        self['myActionMap'] = ActionMap(['SetupActions'], {
            'cancel': self.cancel,
            'ok': self.hledej  
        }, -1)


    def run_command(self):
        cmd = "curl -c /tmp/cookies.txt -o /usr/lib/enigma2/python/Plugins/Extensions/myKCCCAM/x.png 'https://testcline.com/test/cp.php' >> /dev/null 2>&1 </dev/null &"
        os.system(cmd)

    def run_commandX(self):
        cmd = "/usr/lib/enigma2/python/Plugins/Extensions/myKCCCAM/akce.sh >> /dev/null 2>&1 </dev/null &"
        os.system(cmd)
 


    def paintPosterPixmapCB(self, picInfo=None):
        ptr = self.picload.getData()
        if ptr is not None:
            self["poster"].instance.setPixmap(ptr.__deref__())

    def reloadUrl(self):
        with open('/usr/lib/enigma2/python/Plugins/Extensions/myKCCCAM/token.txt', 'r') as file:
            token = file.read().strip()

        cmd = (
            "curl --limit-rate 100K "
            "-Lbk -m 6555 -k 'https://testcline.com/cccam_reseller_panel_free.php' -X POST "
            "-H 'User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:130.0) Gecko/20100101 Firefox/130.0' "
            "-H 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/png,image/svg+xml,*/*;q=0.8' "
            "-H 'Accept-Language: cs,sk;q=0.8,en-US;q=0.5,en;q=0.3' "
            "-H 'Content-Type: application/x-www-form-urlencoded' "
            "-H 'Origin: https://testcline.com' "
            "-H 'Connection: keep-alive' "
            "-H 'Referer: https://testcline.com/cccam_reseller_panel_free.php' "
            "-b /tmp/cookies.txt "
            "-H 'Upgrade-Insecure-Requests: 1' "
            "-H 'Sec-Fetch-Dest: document' "
            "-H 'Sec-Fetch-Mode: navigate' "
            "-H 'Sec-Fetch-Site: same-origin' "
            "-H 'Sec-Fetch-User: ?1' "
            "-H 'Priority: u=0, i' "
            "--data-raw 'protocol=cccam&server=f2.kcccam.cc&vehicle1=agree&access_token={}' > /tmp/x".format(token)
        )

        os.system(cmd)
        self.run_commandX()


    def hledej(self):
        def closeCallback(result):
            if result:
                text = result.strip()
                if text:
                    text = text.replace(" ", "%20")
                    address = "{}".format(text)
                    with open("/usr/lib/enigma2/python/Plugins/Extensions/myKCCCAM/token.txt", "w") as file:
                        file.write(address)
                    self.reloadUrl()

        self.session.openWithCallback(closeCallback, VirtualKeyBoard, title=_("Zde piste text"), text='')

    def cancel(self):
        self.close(False, self.session)
        self.run_command()



def main(session, **kwargs):
    session.open(HalloWorldMsg)


def Plugins(**kwargs):
    return PluginDescriptor(name='my.kcccam.com', description='generator', where=PluginDescriptor.WHERE_PLUGINMENU, icon='/usr/lib/enigma2/python/Plugins/Extensions/myKCCCAM/icon.png', fnc=main)